=== debian/changelog ===
ycm-cmake-modules (0.12.1-1) unstable; urgency=medium

  * New upstream release (0.12.1)

 -- Daniele E. Domenichelli <ddomenichelli@drdanz.it>  Fri, 15 Jan 2021 12:11:40 +0100

ycm-cmake-modules (0.12.0-1) unstable; urgency=medium

  * Initial release (Closes: #934757)

 -- Daniele E. Domenichelli <ddomenichelli@drdanz.it>  Thu, 29 Oct 2020 17:20:06 +0100
