=== debian/control ===
Source: ycm-cmake-modules
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Daniele E. Domenichelli <ddomenichelli@drdanz.it>
Build-Depends:
 debhelper-compat (= 13),
 dh-linktree,
 cmake (>= 3.12),
 python3-sphinx,
 libjs-sphinxdoc (>= 2.4.3-5),
 python3-sphinxcontrib.autoprogram,
 python3-sphinxcontrib.qthelp
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/science-team/ycm-cmake-modules
Vcs-Git: https://salsa.debian.org/science-team/ycm-cmake-modules.git
Homepage: https://robotology.github.io/ycm/
Rules-Requires-Root: no

Package: ycm-cmake-modules
Architecture: all
Depends: ${misc:Depends}, cmake (>= 3.12)
Description: Extra CMake Modules for YARP and friends
 The package YCM contains a set of CMake files that support creation and
 maintenance of repositories and software packages. YCM has been written
 with the aim of solving some of the problems encountered while managing
 large research projects but it can be used outside it initial context.
 .
 YCM is not a replacement to CMake or yet another build system. YCM is
 just a thin layer over CMake. It does not add extra dependencies like
 other build systems, it does not use Python, Ruby, or other scripting
 languages, it is written using CMake language. It is a collection of
 CMake modules, most of them candidate for being contributed upstream.
